/* C utilities

 */

#include <stdio.h>  /* fflish */
#include <stdlib.h>  /* perror, malloc */
#include <string.h>  /* strcpy, strlen */
#include "utils.h"


void panic(char *s)
{
  fflush(NULL);
  fprintf(stderr, "\nPANIC: ");
  perror(s);
  fflush(stderr);
  exit(EXIT_FAILURE);
}


void *safe_malloc(size_t size, char *error_msg)
{
  void *ptr = malloc(size);

  if (! ptr) {
    panic(error_msg);
  }
  return ptr;
}


/* returns a fresh heap-allocated copy of s */
char *strcpy_new(char *s)
{
  char *n = (char *) malloc(strlen(s)+1);
  return strcpy(n, s);
}


/* EOF */
